#!/bin/bash
#check image size/if input image is not 1024x768 then exit programme
imagesize="$( identify -format "%wx%h" $1)"
if [ $imagesize != "1024x768" ]; then 
echo "please format image to 1024x768"
#info="$(identify $1)"
#echo $info#|sed -e "/^[1-9]../p" 
#format image to 1024x768
convert -crop 1024x768+0+0 $1 $1
exit	
fi

#fonc compare two images ,return similar filename /compare sw sh path filename
function compare()
{
image1="$1/$2"
returnfile=image1
returnvalue=1000

#echo "compare"

for image2 in  `ls images` 
do
Mean=$(convert $image1 images/$image2 -compose difference -composite -fx '(r+g+b)/3' miff:-|identify -verbose -|sed -n '/^.*Mean: */{s//scale=2;/;s/(.*)//;s/$/*100\/32768*10/;p;q;}'|bc)
Mean=$(echo $Mean|sed -e 's/\..*//g')

if [ $Mean -lt $returnvalue ]; then
returnfile=$image2
returnvalue=$Mean
fi
done

echo $returnfile
return

}


#creater a directory 
testdir="$(ls -d "Repertoire_$1")"
if [ -n $testdir ]; then
rm -fr "Repertoire_$1"
#rmdir "Repertoire_$1"
echo "Repertoire suprimer"
fi

md="$(mkdir "Repertoire_$1")"
if [ -z $md ];  then
echo "cree un repertoire : Repertoire_$1"
else
echo "error"
fi




#split a image
sw=0
sh=0
paths=""
while [ $sw -le 992 ]
do

while [ $sh -le 736 ]
do 
paths="Repertoire_$1/$sw#$sh"
convert -crop 32x32+$sw+$sh $1  $paths
#identify -verbose "Repertoire_$1/$1_$sw#$sh">"Repertoire_$1/$sw#$sh.ide" 

sh=`expr $sh + 32`
echo -n "."
done
sh=0
sw=`expr $sw + 32`

progresse="$(echo "($sw/1024)*100"|bc -l|sed -e 's/\^*0000*//g'|cut -c1-6)"
echo $progresse"%"

done

echo "....................100%  decoupe image success"



echo "en train analyse base de donne de image........"
echo "recompose l'image mosaique....................."
#convert -size 1024x768 xc:white mosaic_$1
touch script_mosaic
echo "convert -size 1024x768 xc:white ">script_mosaic
echo "create success"
sw=0
sh=0
paths=""
while [ $sw -le 992 ]
do

while [ $sh -le 736 ]
do 
paths="Repertoire_$1"

#echo "$sw#$sh"
#compare $sw $sh $paths "$sw#$sh"
getfile="$(compare $paths "$sw#$sh")"
#echo "filenameget : $getfile"

echo "images/$getfile -geometry 32x32+$sw+$sh -composite ">>script_mosaic
#convert  mosaic_$1 $getfile  -geometry 32x32+$sw+$sh -composite mosaic_$1
#identify -verbose "Repertoire_$1/$1_$sw#$sh">"Repertoire_$1/$sw#$sh.ide" 

sh=`expr $sh + 32`
echo -n "."
done
sh=0
sw=`expr $sw + 32`

progresse="$(echo "($sw/1024)*100"|bc -l|sed -e 's/\^*0000*//g'|cut -c1-6)"
echo $progresse"%"

done
echo "mosaic_test.jpg">>script_mosaic
echo "compose images to new file"
scripts=$(cat script_mosaic)
`$scripts`
echo "finish"
